Index: sys/netinet/if_ether.c
===================================================================
--- sys/netinet/if_ether.c	(revision 195689)
+++ sys/netinet/if_ether.c	(working copy)
@@ -65,7 +65,6 @@
 #include <netinet/in_var.h>
 #include <net/if_llatbl.h>
 #include <netinet/if_ether.h>
-#include <netinet/vinet.h>
 
 #include <net/if_arc.h>
 #include <net/iso88025.h>
@@ -83,28 +82,33 @@
 SYSCTL_NODE(_net_link_ether, PF_INET, inet, CTLFLAG_RW, 0, "");
 
 /* timer values */
-#ifdef VIMAGE_GLOBALS
-static int	arpt_keep; /* once resolved, good for 20 more minutes */
-static int	arp_maxtries;
-int	useloopback; /* use loopback interface for local traffic */
-static int	arp_proxyall;
-#endif
+static VNET_DEFINE(int, arpt_keep) = (20*60);	/* once resolved, good for 20
+						 * minutes */
+static VNET_DEFINE(int, arp_maxtries) = 5;
+static VNET_DEFINE(int, useloopback) = 1;	/* use loopback interface for
+						 * local traffic */
+static VNET_DEFINE(int, arp_proxyall);
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_link_ether_inet, OID_AUTO, max_age,
-    CTLFLAG_RW, arpt_keep, 0, "ARP entry lifetime in seconds");
+#define	V_arpt_keep		VNET_GET(arpt_keep)
+#define	V_arp_maxtries		VNET_GET(arp_maxtries)
+#define	V_useloopback		VNET_GET(useloopback)
+#define	V_arp_proxyall		VNET_GET(arp_proxyall)
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_link_ether_inet, OID_AUTO, maxtries,
-	CTLFLAG_RW, arp_maxtries, 0,
+SYSCTL_VNET_INT(_net_link_ether_inet, OID_AUTO, max_age, CTLFLAG_RW,
+	&VNET_NAME(arpt_keep), 0,
+	"ARP entry lifetime in seconds");
+
+SYSCTL_VNET_INT(_net_link_ether_inet, OID_AUTO, maxtries, CTLFLAG_RW,
+	&VNET_NAME(arp_maxtries), 0,
 	"ARP resolution attempts before returning error");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_link_ether_inet, OID_AUTO, useloopback,
-	CTLFLAG_RW, useloopback, 0,
+SYSCTL_VNET_INT(_net_link_ether_inet, OID_AUTO, useloopback, CTLFLAG_RW,
+	&VNET_NAME(useloopback), 0,
 	"Use the loopback interface for local traffic");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_link_ether_inet, OID_AUTO, proxyall,
-	CTLFLAG_RW, arp_proxyall, 0,
+SYSCTL_VNET_INT(_net_link_ether_inet, OID_AUTO, proxyall, CTLFLAG_RW,
+	&VNET_NAME(arp_proxyall), 0,
 	"Enable proxy ARP for all suitable requests");
 
 static void	arp_init(void);
-static int	arp_iattach(const void *);
 void		arprequest(struct ifnet *,
 			struct in_addr *, struct in_addr *, u_char *);
 static void	arpintr(struct mbuf *);
@@ -120,15 +124,6 @@
 	.nh_policy = NETISR_POLICY_SOURCE,
 };
 
-#ifndef VIMAGE_GLOBALS
-static const vnet_modinfo_t vnet_arp_modinfo = {
-	.vmi_id		= VNET_MOD_ARP,
-	.vmi_name	= "arp",
-	.vmi_dependson	= VNET_MOD_INET,
-	.vmi_iattach	= arp_iattach
-};
-#endif /* !VIMAGE_GLOBALS */
-
 #ifdef AF_INET
 void arp_ifscrub(struct ifnet *ifp, uint32_t addr);
 
@@ -263,7 +258,6 @@
 arpresolve(struct ifnet *ifp, struct rtentry *rt0, struct mbuf *m,
 	struct sockaddr *dst, u_char *desten, struct llentry **lle)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct llentry *la = 0;
 	u_int flags = 0;
 	int error, renew;
@@ -482,7 +476,6 @@
 	sin.sin_len = sizeof(struct sockaddr_in);
 	sin.sin_family = AF_INET;
 	sin.sin_addr.s_addr = 0;
-	INIT_VNET_INET(ifp->if_vnet);
 
 	if (ifp->if_bridge)
 		bridged = 1;
@@ -825,29 +818,10 @@
 	ifa->ifa_rtrequest = NULL;
 }
 
-static int
-arp_iattach(const void *unused __unused)
-{
-	INIT_VNET_INET(curvnet);
-
-	V_arpt_keep = (20*60); /* once resolved, good for 20 more minutes */
-	V_arp_maxtries = 5;
-	V_useloopback = 1; /* use loopback interface for local traffic */
-	V_arp_proxyall = 0;
-
-	return (0);
-}
-
 static void
 arp_init(void)
 {
 
-#ifndef VIMAGE_GLOBALS
-	vnet_mod_register(&vnet_arp_modinfo);
-#else
-	arp_iattach(NULL);
-#endif
-
 	netisr_register(&arp_nh);
 }
 SYSINIT(arp, SI_SUB_PROTO_DOMAIN, SI_ORDER_ANY, arp_init, 0);
Index: sys/netinet/ip_fastfwd.c
===================================================================
--- sys/netinet/ip_fastfwd.c	(revision 195689)
+++ sys/netinet/ip_fastfwd.c	(working copy)
@@ -103,20 +103,18 @@
 #include <netinet/ip_var.h>
 #include <netinet/ip_icmp.h>
 #include <netinet/ip_options.h>
-#include <netinet/vinet.h>
 
 #include <machine/in_cksum.h>
 
-#ifdef VIMAGE_GLOBALS
-static int ipfastforward_active;
-#endif
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, fastforwarding,
-    CTLFLAG_RW, ipfastforward_active, 0, "Enable fast IP forwarding");
+static VNET_DEFINE(int, ipfastforward_active);
+#define	V_ipfastforward_active		VNET_GET(ipfastforward_active)
 
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, fastforwarding, CTLFLAG_RW,
+    &VNET_NAME(ipfastforward_active), 0, "Enable fast IP forwarding");
+
 static struct sockaddr_in *
 ip_findroute(struct route *ro, struct in_addr dest, struct mbuf *m)
 {
-	INIT_VNET_INET(curvnet);
 	struct sockaddr_in *dst;
 	struct rtentry *rt;
 
@@ -160,7 +158,6 @@
 struct mbuf *
 ip_fastforward(struct mbuf *m)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip;
 	struct mbuf *m0 = NULL;
 	struct route ro;
Index: sys/netinet/tcp_timewait.c
===================================================================
--- sys/netinet/tcp_timewait.c	(revision 195689)
+++ sys/netinet/tcp_timewait.c	(working copy)
@@ -87,7 +87,6 @@
 #include <netinet/tcp_debug.h>
 #endif
 #include <netinet6/ip6protosw.h>
-#include <netinet/vinet.h>
 
 #include <machine/in_cksum.h>
 
@@ -101,19 +100,19 @@
  * queue pointers in each tcptw structure, are protected using the global
  * tcbinfo lock, which must be held over queue iteration and modification.
  */
-#ifdef VIMAGE_GLOBALS
-static uma_zone_t tcptw_zone;
-static TAILQ_HEAD(, tcptw)	twq_2msl;
-int	nolocaltimewait;
-#endif
+static VNET_DEFINE(uma_zone_t, tcptw_zone);
+static VNET_DEFINE(TAILQ_HEAD(, tcptw), twq_2msl);
+VNET_DEFINE(int, nolocaltimewait);
 
+#define	V_tcptw_zone			VNET_GET(tcptw_zone)
+#define	V_twq_2msl			VNET_GET(twq_2msl)
+
 static void	tcp_tw_2msl_reset(struct tcptw *, int);
 static void	tcp_tw_2msl_stop(struct tcptw *);
 
 static int
 tcptw_auto_size(void)
 {
-	INIT_VNET_INET(curvnet);
 	int halfrange;
 
 	/*
@@ -131,7 +130,6 @@
 static int
 sysctl_maxtcptw(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET(curvnet);
 	int error, new;
 
 	if (maxtcptw == 0)
@@ -151,14 +149,13 @@
     &maxtcptw, 0, sysctl_maxtcptw, "IU",
     "Maximum number of compressed TCP TIME_WAIT entries");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_tcp, OID_AUTO, nolocaltimewait,
-    CTLFLAG_RW, nolocaltimewait, 0,
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, nolocaltimewait, CTLFLAG_RW,
+    &VNET_NAME(nolocaltimewait), 0,
     "Do not create compressed TCP TIME_WAIT entries for local connections");
 
 void
 tcp_tw_zone_change(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	if (maxtcptw == 0)
 		uma_zone_set_max(V_tcptw_zone, tcptw_auto_size());
@@ -167,7 +164,6 @@
 void
 tcp_tw_init(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	V_tcptw_zone = uma_zcreate("tcptw", sizeof(struct tcptw),
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
@@ -183,7 +179,6 @@
 void
 tcp_tw_destroy(void)
 {
-	INIT_VNET_INET(curvnet);
 	struct tcptw *tw;
 
 	INP_INFO_WLOCK(&V_tcbinfo);
@@ -201,7 +196,6 @@
 void
 tcp_twstart(struct tcpcb *tp)
 {
-	INIT_VNET_INET(tp->t_vnet);
 	struct tcptw *tw;
 	struct inpcb *inp = tp->t_inpcb;
 	int acknow;
@@ -317,7 +311,6 @@
 int
 tcp_twrecycleable(struct tcptw *tw)
 {
-	INIT_VNET_INET(curvnet);
 	tcp_seq new_iss = tw->iss;
 	tcp_seq new_irs = tw->irs;
 
@@ -340,9 +333,6 @@
 tcp_twcheck(struct inpcb *inp, struct tcpopt *to, struct tcphdr *th,
     struct mbuf *m, int tlen)
 {
-#if defined(INVARIANTS) || defined(INVARIANT_SUPPORT)
-	INIT_VNET_INET(curvnet);
-#endif
 	struct tcptw *tw;
 	int thflags;
 	tcp_seq seq;
@@ -434,7 +424,6 @@
 void
 tcp_twclose(struct tcptw *tw, int reuse)
 {
-	INIT_VNET_INET(curvnet);
 	struct socket *so;
 	struct inpcb *inp;
 
@@ -496,7 +485,6 @@
 int
 tcp_twrespond(struct tcptw *tw, int flags)
 {
-	INIT_VNET_INET(curvnet);
 	struct inpcb *inp = tw->tw_inpcb;
 	struct tcphdr *th;
 	struct mbuf *m;
@@ -590,7 +578,6 @@
 static void
 tcp_tw_2msl_reset(struct tcptw *tw, int rearm)
 {
-	INIT_VNET_INET(curvnet);
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 	INP_WLOCK_ASSERT(tw->tw_inpcb);
@@ -603,7 +590,6 @@
 static void
 tcp_tw_2msl_stop(struct tcptw *tw)
 {
-	INIT_VNET_INET(curvnet);
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 	TAILQ_REMOVE(&V_twq_2msl, tw, tw_2msl);
@@ -612,7 +598,6 @@
 struct tcptw *
 tcp_tw_2msl_scan(int reuse)
 {
-	INIT_VNET_INET(curvnet);
 	struct tcptw *tw;
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
Index: sys/netinet/udp_usrreq.c
===================================================================
--- sys/netinet/udp_usrreq.c	(revision 195689)
+++ sys/netinet/udp_usrreq.c	(working copy)
@@ -80,7 +80,6 @@
 #endif
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
-#include <netinet/vinet.h>
 
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
@@ -96,9 +95,7 @@
  * Per RFC 768, August, 1980.
  */
 
-#ifdef VIMAGE_GLOBALS
-int	udp_blackhole;
-#endif
+VNET_DEFINE(int, udp_blackhole);
 
 /*
  * BSD 4.2 defaulted the udp checksum to be off.  Turning off udp checksums
@@ -114,8 +111,8 @@
 SYSCTL_INT(_net_inet_udp, OID_AUTO, log_in_vain, CTLFLAG_RW,
     &udp_log_in_vain, 0, "Log all incoming UDP packets");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_udp, OID_AUTO, blackhole,
-    CTLFLAG_RW, udp_blackhole, 0,
+SYSCTL_VNET_INT(_net_inet_udp, OID_AUTO, blackhole, CTLFLAG_RW,
+    &VNET_NAME(udp_blackhole), 0,
     "Do not send port unreachables for refused connects");
 
 u_long	udp_sendspace = 9216;		/* really max datagram size */
@@ -134,19 +131,19 @@
 SYSCTL_ULONG(_net_inet_udp, UDPCTL_RECVSPACE, recvspace, CTLFLAG_RW,
     &udp_recvspace, 0, "Maximum space for incoming UDP datagrams");
 
-#ifdef VIMAGE_GLOBALS
-struct inpcbhead	udb;		/* from udp_var.h */
-struct inpcbinfo	udbinfo;
-static uma_zone_t	udpcb_zone;
-struct udpstat		udpstat;	/* from udp_var.h */
-#endif
+VNET_DEFINE(struct inpcbhead, udb);		/* from udp_var.h */
+VNET_DEFINE(struct inpcbinfo, udbinfo);
+static VNET_DEFINE(uma_zone_t, udpcb_zone);
+VNET_DEFINE(struct udpstat, udpstat);		/* from udp_var.h */
 
+#define	V_udpcb_zone			VNET_GET(udpcb_zone)
+
 #ifndef UDBHASHSIZE
 #define	UDBHASHSIZE	128
 #endif
 
-SYSCTL_V_STRUCT(V_NET, vnet_inet, _net_inet_udp, UDPCTL_STATS, stats,
-    CTLFLAG_RW, udpstat, udpstat,
+SYSCTL_VNET_STRUCT(_net_inet_udp, UDPCTL_STATS, stats, CTLFLAG_RW,
+    &VNET_NAME(udpstat), udpstat,
     "UDP statistics (struct udpstat, netinet/udp_var.h)");
 
 static void	udp_detach(struct socket *so);
@@ -164,7 +161,6 @@
 static void
 udp_zone_change(void *tag)
 {
-	INIT_VNET_INET(curvnet);
 
 	uma_zone_set_max(V_udbinfo.ipi_zone, maxsockets);
 	uma_zone_set_max(V_udpcb_zone, maxsockets);
@@ -183,7 +179,6 @@
 void
 udp_init(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	V_udp_blackhole = 0;
 
@@ -212,7 +207,6 @@
 int
 udp_newudpcb(struct inpcb *inp)
 {
-	INIT_VNET_INET(curvnet);
 	struct udpcb *up;
 
 	up = uma_zalloc(V_udpcb_zone, M_NOWAIT | M_ZERO);
@@ -225,7 +219,6 @@
 void
 udp_discardcb(struct udpcb *up)
 {
-	INIT_VNET_INET(curvnet);
 
 	uma_zfree(V_udpcb_zone, up);
 }
@@ -234,7 +227,6 @@
 void
 udp_destroy(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	hashdestroy(V_udbinfo.ipi_hashbase, M_PCB,
 	    V_udbinfo.ipi_hashmask);
@@ -274,7 +266,6 @@
 #ifdef IPSEC
 	/* Check AH/ESP integrity. */
 	if (ipsec4_in_reject(n, inp)) {
-		INIT_VNET_IPSEC(curvnet);
 		m_freem(n);
 		V_ipsec4stat.in_polvio++;
 		return;
@@ -321,7 +312,6 @@
 	so = inp->inp_socket;
 	SOCKBUF_LOCK(&so->so_rcv);
 	if (sbappendaddr_locked(&so->so_rcv, append_sa, n, opts) == 0) {
-		INIT_VNET_INET(so->so_vnet);
 		SOCKBUF_UNLOCK(&so->so_rcv);
 		m_freem(n);
 		if (opts)
@@ -334,7 +324,6 @@
 void
 udp_input(struct mbuf *m, int off)
 {
-	INIT_VNET_INET(curvnet);
 	int iphlen = off;
 	struct ip *ip;
 	struct udphdr *uh;
@@ -668,7 +657,6 @@
 void
 udp_ctlinput(int cmd, struct sockaddr *sa, void *vip)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip = vip;
 	struct udphdr *uh;
 	struct in_addr faddr;
@@ -715,7 +703,6 @@
 static int
 udp_pcblist(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET(curvnet);
 	int error, i, n;
 	struct inpcb *inp, **inp_list;
 	inp_gen_t gencnt;
@@ -814,7 +801,6 @@
 static int
 udp_getcred(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET(curvnet);
 	struct xucred xuc;
 	struct sockaddr_in addrs[2];
 	struct inpcb *inp;
@@ -949,7 +935,6 @@
 udp_output(struct inpcb *inp, struct mbuf *m, struct sockaddr *addr,
     struct mbuf *control, struct thread *td)
 {
-	INIT_VNET_INET(inp->inp_vnet);
 	struct udpiphdr *ui;
 	int len = m->m_pkthdr.len;
 	struct in_addr faddr, laddr;
@@ -1270,7 +1255,6 @@
 static struct mbuf *
 udp4_espdecap(struct inpcb *inp, struct mbuf *m, int off)
 {
-	INIT_VNET_IPSEC(curvnet);
 	size_t minlen, payload, skip, iphlen;
 	caddr_t data;
 	struct udpcb *up;
@@ -1397,7 +1381,6 @@
 static void
 udp_abort(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 
 	inp = sotoinpcb(so);
@@ -1416,7 +1399,6 @@
 static int
 udp_attach(struct socket *so, int proto, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	int error;
 
@@ -1480,7 +1462,6 @@
 static int
 udp_bind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	int error;
 
@@ -1497,7 +1478,6 @@
 static void
 udp_close(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 
 	inp = sotoinpcb(so);
@@ -1516,7 +1496,6 @@
 static int
 udp_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	int error;
 	struct sockaddr_in *sin;
@@ -1548,7 +1527,6 @@
 static void
 udp_detach(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	struct udpcb *up;
 
@@ -1570,7 +1548,6 @@
 static int
 udp_disconnect(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 
 	inp = sotoinpcb(so);
Index: sys/netinet/igmp.c
===================================================================
--- sys/netinet/igmp.c	(revision 195689)
+++ sys/netinet/igmp.c	(working copy)
@@ -75,7 +75,6 @@
 #include <netinet/ip_options.h>
 #include <netinet/igmp.h>
 #include <netinet/igmp_var.h>
-#include <netinet/vinet.h>
 
 #include <machine/in_cksum.h>
 
@@ -212,55 +211,72 @@
  * FUTURE: Stop using IFP_TO_IA/INADDR_ANY, and use source address selection
  * policy to control the address used by IGMP on the link.
  */
-#ifdef VIMAGE_GLOBALS
-int	 interface_timers_running;	 /* IGMPv3 general query response */
-int	 state_change_timers_running;	 /* IGMPv3 state-change retransmit */
-int	 current_state_timers_running;	 /* IGMPv1/v2 host report;
-					  * IGMPv3 g/sg query response */
+static VNET_DEFINE(int, interface_timers_running);	/* IGMPv3 general
+							 * query response */
+static VNET_DEFINE(int, state_change_timers_running);	/* IGMPv3 state-change
+							 * retransmit */
+static VNET_DEFINE(int, current_state_timers_running);	/* IGMPv1/v2 host
+							 * report; IGMPv3 g/sg
+							 * query response */
 
-LIST_HEAD(, igmp_ifinfo)	 igi_head;
-struct igmpstat			 igmpstat;
-struct timeval			 igmp_gsrdelay;
+#define	V_interface_timers_running	VNET_GET(interface_timers_running)
+#define	V_state_change_timers_running	VNET_GET(state_change_timers_running)
+#define	V_current_state_timers_running	VNET_GET(current_state_timers_running)
 
-int	 igmp_recvifkludge;
-int	 igmp_sendra;
-int	 igmp_sendlocal;
-int	 igmp_v1enable;
-int	 igmp_v2enable;
-int	 igmp_legacysupp;
-int	 igmp_default_version;
-#endif /* VIMAGE_GLOBALS */
+static VNET_DEFINE(LIST_HEAD(, igmp_ifinfo), igi_head);
+static VNET_DEFINE(struct igmpstat, igmpstat);
+static VNET_DEFINE(struct timeval, igmp_gsrdelay) = {10, 0};
 
+#define	V_igi_head			VNET_GET(igi_head)
+#define	V_igmpstat			VNET_GET(igmpstat)
+#define	V_igmp_gsrdelay			VNET_GET(igmp_gsrdelay)
+
+static VNET_DEFINE(int, igmp_recvifkludge) = 1;
+static VNET_DEFINE(int, igmp_sendra) = 1;
+static VNET_DEFINE(int, igmp_sendlocal) = 1;
+static VNET_DEFINE(int, igmp_v1enable) = 1;
+static VNET_DEFINE(int, igmp_v2enable) = 1;
+static VNET_DEFINE(int, igmp_legacysupp);
+static VNET_DEFINE(int, igmp_default_version) = IGMP_VERSION_3;
+
+#define	V_igmp_recvifkludge		VNET_GET(igmp_recvifkludge)
+#define	V_igmp_sendra			VNET_GET(igmp_sendra)
+#define	V_igmp_sendlocal		VNET_GET(igmp_sendlocal)
+#define	V_igmp_v1enable			VNET_GET(igmp_v1enable)
+#define	V_igmp_v2enable			VNET_GET(igmp_v2enable)
+#define	V_igmp_legacysupp		VNET_GET(igmp_legacysupp)
+#define	V_igmp_default_version		VNET_GET(igmp_default_version)
+
 /*
  * Virtualized sysctls.
  */
-SYSCTL_V_STRUCT(V_NET, vnet_inet, _net_inet_igmp, IGMPCTL_STATS, stats,
-    CTLFLAG_RW, igmpstat, igmpstat, "");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, recvifkludge,
-    CTLFLAG_RW, igmp_recvifkludge, 0,
+SYSCTL_VNET_STRUCT(_net_inet_igmp, IGMPCTL_STATS, stats, CTLFLAG_RW,
+    &VNET_NAME(igmpstat), igmpstat, "");
+SYSCTL_VNET_INT(_net_inet_igmp, OID_AUTO, recvifkludge, CTLFLAG_RW,
+    &VNET_NAME(igmp_recvifkludge), 0,
     "Rewrite IGMPv1/v2 reports from 0.0.0.0 to contain subnet address");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, sendra,
-    CTLFLAG_RW, igmp_sendra, 0,
+SYSCTL_VNET_INT(_net_inet_igmp, OID_AUTO, sendra, CTLFLAG_RW,
+    &VNET_NAME(igmp_sendra), 0,
     "Send IP Router Alert option in IGMPv2/v3 messages");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, sendlocal,
-    CTLFLAG_RW, igmp_sendlocal, 0,
+SYSCTL_VNET_INT(_net_inet_igmp, OID_AUTO, sendlocal, CTLFLAG_RW,
+    &VNET_NAME(igmp_sendlocal), 0,
     "Send IGMP membership reports for 224.0.0.0/24 groups");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, v1enable,
-    CTLFLAG_RW, igmp_v1enable, 0,
+SYSCTL_VNET_INT(_net_inet_igmp, OID_AUTO, v1enable, CTLFLAG_RW,
+    &VNET_NAME(igmp_v1enable), 0,
     "Enable backwards compatibility with IGMPv1");
-SYSCTL_V_INT(V_NET, vnet_inet,  _net_inet_igmp, OID_AUTO, v2enable,
-    CTLFLAG_RW, igmp_v2enable, 0,
+SYSCTL_VNET_INT(_net_inet_igmp, OID_AUTO, v2enable, CTLFLAG_RW,
+    &VNET_NAME(igmp_v2enable), 0,
     "Enable backwards compatibility with IGMPv2");
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, legacysupp,
-    CTLFLAG_RW, igmp_legacysupp, 0,
+SYSCTL_VNET_INT(_net_inet_igmp, OID_AUTO, legacysupp, CTLFLAG_RW,
+    &VNET_NAME(igmp_legacysupp), 0,
     "Allow v1/v2 reports to suppress v3 group responses");
-SYSCTL_V_PROC(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, default_version,
-    CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE, igmp_default_version, 0,
-    sysctl_igmp_default_version, "I",
+SYSCTL_VNET_PROC(_net_inet_igmp, OID_AUTO, default_version,
+    CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE,
+    &VNET_NAME(igmp_default_version), 0, sysctl_igmp_default_version, "I",
     "Default version of IGMP to run on each interface");
-SYSCTL_V_PROC(V_NET, vnet_inet, _net_inet_igmp, OID_AUTO, gsrdelay,
-    CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE, igmp_gsrdelay.tv_sec, 0,
-    sysctl_igmp_gsr, "I",
+SYSCTL_VNET_PROC(_net_inet_igmp, OID_AUTO, gsrdelay,
+    CTLTYPE_INT | CTLFLAG_RW | CTLFLAG_MPSAFE,
+    &VNET_NAME(igmp_gsrdelay.tv_sec), 0, sysctl_igmp_gsr, "I",
     "Rate limit for IGMPv3 Group-and-Source queries in seconds");
 
 /*
@@ -327,7 +343,6 @@
 static int
 sysctl_igmp_default_version(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET(curvnet);
 	int	 error;
 	int	 new;
 
@@ -367,7 +382,6 @@
 static int
 sysctl_igmp_gsr(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET(curvnet);
 	int error;
 	int i;
 
@@ -408,8 +422,6 @@
 static int
 sysctl_igmp_ifinfo(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET(curvnet);
 	int			*name;
 	int			 error;
 	u_int			 namelen;
@@ -495,7 +507,6 @@
 static __inline int
 igmp_isgroupreported(const struct in_addr addr)
 {
-	INIT_VNET_INET(curvnet);
 
 	if (in_allhosts(addr) ||
 	    ((!V_igmp_sendlocal && IN_LOCAL_GROUP(ntohl(addr.s_addr)))))
@@ -553,7 +564,6 @@
 static struct igmp_ifinfo *
 igi_alloc_locked(/*const*/ struct ifnet *ifp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct igmp_ifinfo *igi;
 
 	IGMP_LOCK_ASSERT();
@@ -661,7 +671,6 @@
 static void
 igi_delete_locked(const struct ifnet *ifp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct igmp_ifinfo *igi, *tigi;
 
 	CTR3(KTR_IGMPV3, "%s: freeing igmp_ifinfo for ifp %p(%s)",
@@ -702,7 +711,6 @@
 igmp_input_v1_query(struct ifnet *ifp, const struct ip *ip,
     const struct igmp *igmp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct ifmultiaddr	*ifma;
 	struct igmp_ifinfo	*igi;
 	struct in_multi		*inm;
@@ -788,7 +796,6 @@
 igmp_input_v2_query(struct ifnet *ifp, const struct ip *ip,
     const struct igmp *igmp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct ifmultiaddr	*ifma;
 	struct igmp_ifinfo	*igi;
 	struct in_multi		*inm;
@@ -893,7 +900,6 @@
 static void
 igmp_v2_update_group(struct in_multi *inm, const int timer)
 {
-	INIT_VNET_INET(curvnet);
 
 	CTR4(KTR_IGMPV3, "%s: %s/%s timer=%d", __func__,
 	    inet_ntoa(inm->inm_addr), inm->inm_ifp->if_xname, timer);
@@ -941,7 +947,6 @@
 igmp_input_v3_query(struct ifnet *ifp, const struct ip *ip,
     /*const*/ struct igmpv3 *igmpv3)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct igmp_ifinfo	*igi;
 	struct in_multi		*inm;
 	int			 is_general_query;
@@ -1106,7 +1111,6 @@
 igmp_input_v3_group_query(struct in_multi *inm, struct igmp_ifinfo *igi,
     int timer, /*const*/ struct igmpv3 *igmpv3)
 {
-	INIT_VNET_INET(curvnet);
 	int			 retval;
 	uint16_t		 nsrc;
 
@@ -1209,7 +1213,6 @@
 igmp_input_v1_report(struct ifnet *ifp, /*const*/ struct ip *ip,
     /*const*/ struct igmp *igmp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct in_ifaddr *ia;
 	struct in_multi *inm;
 
@@ -1318,7 +1321,6 @@
 igmp_input_v2_report(struct ifnet *ifp, /*const*/ struct ip *ip,
     /*const*/ struct igmp *igmp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct in_ifaddr *ia;
 	struct in_multi *inm;
 
@@ -1436,7 +1438,6 @@
 	CTR3(KTR_IGMPV3, "%s: called w/mbuf (%p,%d)", __func__, m, off);
 
 	ifp = m->m_pkthdr.rcvif;
-	INIT_VNET_INET(ifp->if_vnet);
 
 	IGMPSTAT_INC(igps_rcv_total);
 
@@ -1633,7 +1634,6 @@
 static void
 igmp_fasttimo_vnet(void)
 {
-	INIT_VNET_INET(curvnet);
 	struct ifqueue		 scq;	/* State-change packets */
 	struct ifqueue		 qrq;	/* Query response packets */
 	struct ifnet		*ifp;
@@ -1756,7 +1756,6 @@
 static void
 igmp_v1v2_process_group_timer(struct in_multi *inm, const int version)
 {
-	INIT_VNET_INET(curvnet);
 	int report_timer_expired;
 
 	IN_MULTI_LOCK_ASSERT();
@@ -1805,7 +1804,6 @@
     struct ifqueue *qrq, struct ifqueue *scq,
     struct in_multi *inm, const int uri_fasthz)
 {
-	INIT_VNET_INET(curvnet);
 	int query_response_timer_expired;
 	int state_change_retransmit_timer_expired;
 
@@ -2083,7 +2081,6 @@
 static void
 igmp_v1v2_process_querier_timers(struct igmp_ifinfo *igi)
 {
-	INIT_VNET_INET(curvnet);
 
 	IGMP_LOCK_ASSERT();
 
@@ -2177,7 +2174,6 @@
 static void
 igmp_slowtimo_vnet(void)
 {
-	INIT_VNET_INET(curvnet);
 	struct igmp_ifinfo *igi;
 
 	IGMP_LOCK();
@@ -2342,7 +2338,6 @@
 static int
 igmp_initial_join(struct in_multi *inm, struct igmp_ifinfo *igi)
 {
-	INIT_VNET_INET(curvnet);
 	struct ifnet		*ifp;
 	struct ifqueue		*ifq;
 	int			 error, retval, syncstates;
@@ -2471,7 +2466,6 @@
 static int
 igmp_handle_state_change(struct in_multi *inm, struct igmp_ifinfo *igi)
 {
-	INIT_VNET_INET(curvnet);
 	struct ifnet		*ifp;
 	int			 retval;
 
@@ -2531,7 +2525,6 @@
 static void
 igmp_final_leave(struct in_multi *inm, struct igmp_ifinfo *igi)
 {
-	INIT_VNET_INET(curvnet);
 	int syncstates;
 
 	syncstates = 1;
@@ -3324,7 +3317,6 @@
 static void
 igmp_v3_dispatch_general_query(struct igmp_ifinfo *igi)
 {
-	INIT_VNET_INET(curvnet);
 	struct ifmultiaddr	*ifma, *tifma;
 	struct ifnet		*ifp;
 	struct in_multi		*inm;
@@ -3412,8 +3404,6 @@
 	 * unique to each VIMAGE and must be retrieved.
 	 */
 	CURVNET_SET((struct vnet *)(m->m_pkthdr.header));
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET(curvnet);
 	ifindex = igmp_restore_context(m);
 
 	/*
@@ -3495,7 +3485,6 @@
 static struct mbuf *
 igmp_v3_encap_report(struct ifnet *ifp, struct mbuf *m)
 {
-	INIT_VNET_INET(curvnet);
 	struct igmp_report	*igmp;
 	struct ip		*ip;
 	int			 hdrlen, igmpreclen;
@@ -3621,30 +3610,14 @@
 static int
 vnet_igmp_iattach(const void *unused __unused)
 {
-	INIT_VNET_INET(curvnet);
 
 	CTR1(KTR_IGMPV3, "%s: initializing", __func__);
 
 	LIST_INIT(&V_igi_head);
 
-	V_current_state_timers_running = 0;
-	V_state_change_timers_running = 0;
-	V_interface_timers_running = 0;
-
 	/*
 	 * Initialize sysctls to default values.
 	 */
-	V_igmp_recvifkludge = 1;
-	V_igmp_sendra = 1;
-	V_igmp_sendlocal = 1;
-	V_igmp_v1enable = 1;
-	V_igmp_v2enable = 1;
-	V_igmp_legacysupp = 0;
-	V_igmp_default_version = IGMP_VERSION_3;
-	V_igmp_gsrdelay.tv_sec = 10;
-	V_igmp_gsrdelay.tv_usec = 0;
-
-	memset(&V_igmpstat, 0, sizeof(struct igmpstat));
 	V_igmpstat.igps_version = IGPS_VERSION_3;
 	V_igmpstat.igps_len = sizeof(struct igmpstat);
 
@@ -3654,9 +3627,6 @@
 static int
 vnet_igmp_idetach(const void *unused __unused)
 {
-#ifdef INVARIANTS
-	INIT_VNET_INET(curvnet);
-#endif
 
 	CTR1(KTR_IGMPV3, "%s: tearing down", __func__);
 
@@ -3666,7 +3636,7 @@
 	return (0);
 }
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static vnet_modinfo_t vnet_igmp_modinfo = {
 	.vmi_id		= VNET_MOD_IGMP,
 	.vmi_name	= "igmp",
@@ -3683,14 +3653,14 @@
     switch (type) {
     case MOD_LOAD:
 	igmp_sysinit();
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_register(&vnet_igmp_modinfo);
 #else
 	vnet_igmp_iattach(NULL);
 #endif
 	break;
     case MOD_UNLOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_deregister(&vnet_igmp_modinfo);
 #else
 	vnet_igmp_idetach(NULL);
Index: sys/netinet/in_rmx.c
===================================================================
--- sys/netinet/in_rmx.c	(revision 195689)
+++ sys/netinet/in_rmx.c	(working copy)
@@ -59,7 +59,6 @@
 #include <netinet/in.h>
 #include <netinet/in_var.h>
 #include <netinet/ip_var.h>
-#include <netinet/vinet.h>
 
 extern int	in_inithead(void **head, int off);
 #ifdef VIMAGE
@@ -132,22 +131,24 @@
 	return rn;
 }
 
-#ifdef VIMAGE_GLOBALS
-static int rtq_reallyold;
-static int rtq_minreallyold;
-static int rtq_toomany;
-#endif
+static VNET_DEFINE(int, rtq_reallyold);
+static VNET_DEFINE(int, rtq_minreallyold);
+static VNET_DEFINE(int, rtq_toomany);
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_RTEXPIRE, rtexpire,
-    CTLFLAG_RW, rtq_reallyold, 0,
+#define	V_rtq_reallyold		VNET_GET(rtq_reallyold)
+#define	V_rtq_minreallyold	VNET_GET(rtq_minreallyold)
+#define	V_rtq_toomany		VNET_GET(rtq_toomany)
+
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_RTEXPIRE, rtexpire, CTLFLAG_RW,
+    &VNET_NAME(rtq_reallyold), 0,
     "Default expiration time on dynamically learned routes");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_RTMINEXPIRE,
-    rtminexpire, CTLFLAG_RW, rtq_minreallyold, 0,
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_RTMINEXPIRE, rtminexpire, CTLFLAG_RW,
+    &VNET_NAME(rtq_minreallyold), 0,
     "Minimum time to attempt to hold onto dynamically learned routes");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_RTMAXCACHE,
-    rtmaxcache, CTLFLAG_RW, rtq_toomany, 0,
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_RTMAXCACHE, rtmaxcache, CTLFLAG_RW,
+    &VNET_NAME(rtq_toomany), 0,
     "Upper limit on dynamically learned routes");
 
 /*
@@ -157,7 +158,6 @@
 static void
 in_clsroute(struct radix_node *rn, struct radix_node_head *head)
 {
-	INIT_VNET_INET(curvnet);
 	struct rtentry *rt = (struct rtentry *)rn;
 
 	RT_LOCK_ASSERT(rt);
@@ -200,7 +200,6 @@
 static int
 in_rtqkill(struct radix_node *rn, void *rock)
 {
-	INIT_VNET_INET(curvnet);
 	struct rtqk_arg *ap = rock;
 	struct rtentry *rt = (struct rtentry *)rn;
 	int err;
@@ -240,18 +239,18 @@
 }
 
 #define RTQ_TIMEOUT	60*10	/* run no less than once every ten minutes */
-#ifdef VIMAGE_GLOBALS
-static int rtq_timeout;
-static struct callout rtq_timer;
-#endif
+static VNET_DEFINE(int, rtq_timeout);
+static VNET_DEFINE(struct callout, rtq_timer);
 
+#define	V_rtq_timeout		VNET_GET(rtq_timeout)
+#define	V_rtq_timer		VNET_GET(rtq_timer)
+
 static void in_rtqtimo_one(void *rock);
 
 static void
 in_rtqtimo(void *rock)
 {
 	CURVNET_SET((struct vnet *) rock);
-	INIT_VNET_INET(curvnet);
 	int fibnum;
 	void *newrock;
 	struct timeval atv;
@@ -270,7 +269,6 @@
 static void
 in_rtqtimo_one(void *rock)
 {
-	INIT_VNET_INET(curvnet);
 	struct radix_node_head *rnh = rock;
 	struct rtqk_arg arg;
 	static time_t last_adjusted_timeout = 0;
@@ -348,7 +346,6 @@
 int
 in_inithead(void **head, int off)
 {
-	INIT_VNET_INET(curvnet);
 	struct radix_node_head *rnh;
 
 	/* XXX MRT
@@ -386,7 +383,6 @@
 int
 in_detachhead(void **head, int off)
 {
-	INIT_VNET_INET(curvnet);
 
 	callout_drain(&V_rtq_timer);
 	return (1);
Index: sys/netgraph/atm/ng_atm.c
===================================================================
--- sys/netgraph/atm/ng_atm.c	(revision 195689)
+++ sys/netgraph/atm/ng_atm.c	(working copy)
@@ -1407,7 +1407,6 @@
 		VNET_LIST_RLOCK();
 		VNET_FOREACH(vnet_iter) {
 			CURVNET_SET_QUIET(vnet_iter);
-			INIT_VNET_NET(vnet_iter);
 			TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
 				if (ifp->if_type == IFT_ATM)
 					ng_atm_attach(ifp);
@@ -1431,7 +1430,6 @@
 		VNET_LIST_RLOCK();
 		VNET_FOREACH(vnet_iter) {
 			CURVNET_SET_QUIET(vnet_iter);
-			INIT_VNET_NET(vnet_iter);
 			TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
 				if (ifp->if_type == IFT_ATM)
 					ng_atm_detach(ifp);
Index: sys/netgraph/ng_eiface.c
===================================================================
--- sys/netgraph/ng_eiface.c	(revision 195689)
+++ sys/netgraph/ng_eiface.c	(working copy)
@@ -116,11 +116,10 @@
 static vnet_attach_fn ng_eiface_iattach;
 static vnet_detach_fn ng_eiface_idetach;
 
-#ifdef VIMAGE_GLOBALS
-static struct unrhdr	*ng_eiface_unit;
-#endif
+static VNET_DEFINE(struct unrhdr *, ng_eiface_unit);
+#define	V_ng_eiface_unit		VNET_GET(ng_eiface_unit)
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static vnet_modinfo_t vnet_ng_eiface_modinfo = {
 	.vmi_id		= VNET_MOD_NG_EIFACE,
 	.vmi_name	= "ng_eiface",
@@ -351,7 +350,6 @@
 static int
 ng_eiface_constructor(node_p node)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	struct ifnet *ifp;
 	priv_p priv;
 	u_char eaddr[6] = {0,0,0,0,0,0};
@@ -563,7 +561,6 @@
 static int
 ng_eiface_rmnode(node_p node)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	const priv_p priv = NG_NODE_PRIVATE(node);
 	struct ifnet *const ifp = priv->ifp;
 
@@ -604,14 +601,14 @@
 
 	switch (event) {
 	case MOD_LOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_register(&vnet_ng_eiface_modinfo);
 #else
 		ng_eiface_iattach(NULL);
 #endif
 		break;
 	case MOD_UNLOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_deregister(&vnet_ng_eiface_modinfo);
 #else
 		ng_eiface_idetach(NULL);
@@ -626,7 +623,6 @@
 
 static int ng_eiface_iattach(const void *unused)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 
 	V_ng_eiface_unit = new_unrhdr(0, 0xffff, NULL);
 
@@ -635,7 +631,6 @@
 
 static int ng_eiface_idetach(const void *unused)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 
 	delete_unrhdr(V_ng_eiface_unit);
 
